// fuse incoming events into one.
// could be used to construct Pmono(a, b, ...) = Pfuse(a, b) <> Pbind(...)


Pfuse : Pattern {
	
	var <>name, <>args;
	
	*new { arg name, args;
		^super.newCopyArgs(name, args)
	}
	
	embedInStream { arg inevent;
		var event, server, id;
		var childHasFinished;
		
		if(inevent.isNil) { ^inevent };
		
		server = inevent[\server] ?? { Server.default };
		id = server.nextNodeID;
		
		if(inevent.eventAt(\type) == \end) { 
			^inevent.put(\type, nil) // if early return avoid recursion
		};
											
		event = inevent.copy;
		event[\type] = \on;
		event[\id] = id;
		event[\instrument] = name;
		event[\args] = args;
			
		server.makeSafeBundle(server.latency, {
			inevent = event.yield;
		});
		
		loop {
			
			
			// finishing: cleaning up.
			if(inevent.eventAt(\type) == \finish) {
					event = (event ? inevent).copy; // but return outgoing stream
					childHasFinished = event.eventAt(\finishEvents).isNil;
				// this current event is the one that 
				// will be used for cleaning up after finishing
				
					event[\delta] = 0;
					event[\id] = id;
					event[\type] = \off;
					event.copyToFinishEvents; 
				
					
					event[\type] = \finish;
					inevent = event.yield;
					if(childHasFinished) { ^inevent } // if still on the way, continue
			
			};
			
			if(inevent.isNil) {
					event = Event.new;
					event[\type] = \off;
					event[\id] = id;
					event[\delta] = 0;
					^event.yield;
			};
			
			event = inevent.copy;
			event[\type] = \set;
			event[\id] = id;
			event[\args] = args;

			inevent = event.yield;
		}
	}
}
